module MPH
  class Transfer
    require 'uri'
    require 'net/http'
    require 'net/ftp'

    def get_file(file)
      localfile = File::basename(file)
      if @uri.is_a? URI::HTTP
        if !@connection.active?
          @connection.start
        end
        path = @uri.path + file
        @msg.print(MsgLevel::NORMAL,"#{@uri}#{file}\n")
        File.open(localfile,"w") do |f|
          begin
            @connection.get(path,@header) do |content|
              f.write content
            end
          rescue EOFError
            @connection = Net::HTTP.new(@uri.host,@uri.port)
            @connection.start
            retry
          end
        end
      elsif @uri.is_a? URI::FTP
        @msg.print(MsgLevel::NORMAL,"#{@uri}#{file}\n")
        begin
          if !@connection || @connection.closed?
            @connection = Net::FTP.open(@uri.host)
            @connection.passive = true
            @connection.login
          end
          @connection.getbinaryfile(@uri.path+file,localfile)
        rescue EOFError
          @connection = nil
          retry
        end
      else
        begin
          File.unlink(localfile)
        rescue
        end
        sCommand = @uri.gsub( '%s', file )
        @msg.print(MsgLevel::NORMAL, "#{sCommand}\n")
        system( sCommand )
      end
      if test(?e,localfile)
        true
      else
        false
      end
    end

    def close_session
      if uri.is_a? URI::HTTP
        @connection.finish
      elsif uri.is_a? URI::FTP
        @connection.close
      end
    end
   
    def initialize(uribase)
      @msg = Msg.instance
      uri = uribase.gsub('%s','')
      begin
        @uri = URI.parse(uri)
        @header = {}
	@header["User-Agent"]="mph-get/#{MPH::VERSION}"
      rescue URI::InvalidURIError
        @uri = uribase
      end
      if @uri.is_a? URI::HTTP
        @connection = Net::HTTP.new(@uri.host,@uri.port)
      elsif @uri.is_a? URI::FTP
        @connection = nil
      end
    end
    private :initialize
  end
end
